window.requestAnimFrame = (function(){
	//var refreshRate = Android.deviceScreenRefreshRate();
	var refreshRate = 60;
	//if (Android.allowRequestAnimFrame()) {
	if (true) {
		return window.requestAnimationFrame    ||
			window.webkitRequestAnimationFrame ||
			window.mozRequestAnimationFrame    ||
			function( callback ){
				window.setTimeout(callback, 1000 / refreshRate);
			};
	} else {
		return function( callback ){
			window.setTimeout(callback, 1000 / refreshRate);
		};
	}
})();


var timer = (function () {
	var startTime = 0;

	function start() {
		var d = new Date();
		startTime = d.getTime();
	}

	function stop() {
		var d = new Date();
		return d.getTime() - startTime;
	}

	// PUBLIC REVEAL **********
	return {
		start : start,
		stop  : stop
	}
})();


var meter = (function () {
	var _frame = 0,
		_startTime = 0;

	function start() {
		_startTime = (new Date()).getTime();
		_frame = 0;
	}

	function run() {
		requestAnimFrame(function () {
			$(document).trigger("FMAnimationEvent");
			run();
		});
		_frame++;
	}

	function averageFps() {
		var endTime = (new Date()).getTime();
		return _frame / ((endTime - _startTime) / 1000);
	}

	// PUBLIC REVEAL **********
	return {
		start      : start,
		run        : run,
		averageFps : averageFps
	}
})();